#include <pigpio.h>
#include <iostream>
#include <unistd.h>

using namespace std;

uint16_t dataRed[40*24] = {0};
uint16_t dataGreen[40*24] = {0};
char dataRed2[40*24*2] = {0};
char dataGreen2[40*24*2] = {0};
char ures[40*24*2] = {0};

void initData()
{
  for(size_t i = 0; i < 40; i++)
  {
    for(size_t j = 0; j < 24; j++)
    {
      dataRed[24*i+j] = 0;
    }    
    dataRed[24*i] = 0x0100;
  }
  for(size_t i = 0; i < 40; i++)
  {
    for(size_t j = 0; j < 24; j++)
    {
      dataGreen[24*i+j] = 0;
    }    
    dataGreen[24*i+8] = 0x0100;
  }
  for(size_t i = 0; i < 40*24; i++)
  {
    dataRed2[2*i] = dataRed[i] >> 8;
    dataRed2[2*i + 1] = dataRed[i];
    dataGreen2[2*i] = dataGreen[i] >> 8;
    dataGreen2[2*i + 1] = dataGreen[i];
  }
}

int main(int argc, char *argv[])
{
  initData();
  gpioInitialise();
  int spiHandle = spiOpen(0, 16000000, 0b0100000000000000000000);
  if(spiHandle >= 0) cout << "SPI Opened" << endl;
  char buff[2] = {0, 1}; //ez lesz így 0x0001
  while(1){
    spiWrite(spiHandle, dataRed2, 40*24*2);
    usleep(10000);
    spiWrite(spiHandle, dataGreen2, 40*24*2);
    usleep(10000);
  }
  
  return 0;
}
